final class RSInterface extends NodeSub {
	
    int x;
    int parentID;
    int disabledSprite;
    int frameDelay = 0;
    int height;
    int mediaIdDisabled;
    int modelTypeDisabled;
    RSString spellName;
    int anInt1748;
    int[] requiredValues;
    private int mediaTypeEnabled;
    int shadeColor;
    int width;
    int textAlignment = 0;
    int rotateY;
    int enabledSprite;
    int enabledAnim;
    RSString disabledText;
    RSString selectedActionName;
    int animationDelay = 0;
    int invSpritePadY;
    boolean hasDrop;
    int disabledMouseOverColor;
    RSString[] actions;
    int scrollMax;
    int zoom;
    int[] inv;
    int type;
    int disabledAnim;
    int scrollPosition;
    int actionType;
    RSString tooltip;
    int rotateX;
    int[] spriteID;
    int[] invStackSizes;
    RSString enabledText;
    int invSpritePadX = 0;
    int[] valueCompareType;
    boolean shaded;
    boolean swapDeletesTarget;
    int font;
    boolean hasUse;
    int[] spriteX;
    int enabledMouseOverColor;
    int offsetY;
    int enabledColor;
    boolean isHidden;
    int[][] cs1opcodes;
    int offsetX;
    boolean itemsCanBeSwapped;
    int spellUseModifier;
    boolean filled;
    int y;
    int mouseOverID;
    int contentType;
    int anInt1805;
    int[] spriteY;
    int rotateSpeed;
    private int mediaIdEnabled;
    int disabledColor;
    
    final Sprite getSprite(boolean enabled) {
    	int spriteId;
    	if (!enabled)
    		spriteId = disabledSprite;
    	else
    		spriteId = enabledSprite;
    	Client.spriteIsNull = false;
    	if (spriteId == -1)
    		return null;
    	Sprite sprite = (Sprite) Client.spriteCache.get((long) spriteId);
    	if (sprite != null)
    		return sprite;
    	sprite = Client.fetchSingleSprite(0, Client.interfaceSpriteFetcher, spriteId);
    	if (sprite == null)
    		Client.spriteIsNull = true;
    	else
    		Client.spriteCache.put(sprite, (long) spriteId);
    	return sprite;
    }
    
    final void read(Stream stream) {
    	type = stream.getUByte();
		actionType = stream.getUByte();
		contentType = stream.getUShort();
		x = offsetX = stream.getShort();
		y = offsetY = stream.getShort();
		width = stream.getUShort();
		height = stream.getUShort();
		shadeColor = stream.getUByte();
		parentID = stream.getUShort();
		if (parentID == 65535)
			parentID = -1;
		mouseOverID = stream.getUShort();
		if (mouseOverID == 65535)
			mouseOverID = -1;
		int valuecomparecount = stream.getUByte();
		if (valuecomparecount > 0) {
			valueCompareType = new int[valuecomparecount];
			requiredValues = new int[valuecomparecount];
			for (int id = 0; valuecomparecount > id; id++) {
				valueCompareType[id] = stream.getUByte();
				requiredValues[id] = stream.getUShort();
			}
		}
		int cs1length = stream.getUByte();
		if (cs1length > 0) {
			cs1opcodes = new int[cs1length][];
			for (int blockIdx = 0; blockIdx < cs1length; blockIdx++) {
				int cs1blocklen = stream.getUShort();
				cs1opcodes[blockIdx] = new int[cs1blocklen];
				for (int cs1opcIdx = 0; cs1blocklen > cs1opcIdx; cs1opcIdx++) {
					cs1opcodes[blockIdx][cs1opcIdx] = stream.getUShort();
					if ((cs1opcodes[blockIdx][cs1opcIdx]) == 65535)
						cs1opcodes[blockIdx][cs1opcIdx] = -1;
				}
			}
		}
		if (type == 0) {
			scrollMax = stream.getUShort();
			isHidden = stream.getUByte() == 1;
		}
		if (type == 1) {
			stream.getUShort();
			stream.getUByte();
		}
		if (type == 2) {
			inv = new int[height * width];
			invStackSizes = new int[height * width];
			itemsCanBeSwapped = stream.getUByte() == 1;
			hasDrop = stream.getUByte() == 1;
			hasUse = stream.getUByte() == 1;
			swapDeletesTarget = stream.getUByte() == 1;
			invSpritePadX = stream.getUByte();
			invSpritePadY = stream.getUByte();
			spriteID = new int[20];
			spriteX = new int[20];
			spriteY = new int[20];
			for (int spriteIDX = 0; spriteIDX < 20; spriteIDX++) {
				int spriteEnabled = stream.getUByte();
				if (spriteEnabled != 1)
					spriteID[spriteIDX] = -1;
				else {
					spriteX[spriteIDX] = stream.getShort();
					spriteY[spriteIDX] = stream.getShort();
					spriteID[spriteIDX] = stream.getInt();
				}
			}
			actions = new RSString[5];
			for (int actionIdx = 0; actionIdx < 5; actionIdx++) {
				actions[actionIdx] = stream.getString();
				if (actions[actionIdx].length() == 0)
					actions[actionIdx] = null;
			}
		}
		if (type == 3)
			filled = stream.getUByte() == 1;
		if (type == 4 || type == 1) {
		    textAlignment = stream.getUByte();
		    anInt1805 = stream.getUByte();
		    anInt1748 = stream.getUByte();
		    font = stream.getUByte();
		    shaded = stream.getUByte() == 1;
		}
		if (type == 4) {
		    disabledText = stream.getString();
		    enabledText = stream.getString();
		}
		if (type == 1 || type == 3 || type == 4)
		    disabledColor = stream.getInt();
		if (type == 3 || type == 4) {
		    enabledColor = stream.getInt();
		    disabledMouseOverColor = stream.getInt();
		    enabledMouseOverColor = stream.getInt();
		}
		if (type == 5) {
			disabledSprite = stream.getInt();
			enabledSprite = stream.getInt();
		}
		if (type == 6) {
			modelTypeDisabled = 1;
			mediaIdDisabled = stream.getUShort();
			if (mediaIdDisabled == 65535)
			    mediaIdDisabled = -1;
			mediaTypeEnabled = 1;
			mediaIdEnabled = stream.getUShort();
			if (mediaIdEnabled == 65535)
			    mediaIdEnabled = -1;
			disabledAnim = stream.getUShort();
			if (disabledAnim == 65535)
			    disabledAnim = -1;
			enabledAnim = stream.getUShort();
			if (enabledAnim == 65535)
			    enabledAnim = -1;
			zoom = stream.getUShort();
			rotateX = stream.getUShort();
			rotateY = stream.getUShort();
		}
		if (type == 7) {
			inv = new int[(height * width)];
			invStackSizes = new int[(width * height)];
			textAlignment = stream.getUByte();
			font = stream.getUByte();
			shaded = stream.getUByte() == 1;
			disabledColor = stream.getInt();
			invSpritePadX = stream.getShort();
			invSpritePadY = stream.getShort();
			hasDrop = stream.getUByte() == 1;
			actions = new RSString[5];
			for (int id = 0; id < 5; id++) {
			    actions[id] = stream.getString();
			    if (actions[id].length() == 0)
					actions[id] = null;
			}
		}
		if (type == 8)
			disabledText = stream.getString();
		if (actionType == 2 || type == 2) {
			selectedActionName = stream.getString();
			spellName = stream.getString();
			spellUseModifier = stream.getUShort();
		}
		if (actionType == 1 || actionType == 4 || actionType == 5 || actionType == 6) {
			tooltip = stream.getString();
			if (tooltip.length() == 0) {
				if (actionType == 1)
					tooltip = Client.ok;
				if (actionType == 4)
					tooltip = Client.select;
				if (actionType == 5)
					tooltip = Client.select;
				if (actionType == 6)
					tooltip = Client.continueString;
			}
		}
    }
    
    final Model getModel(boolean enabled, PlayerAppearance class34, int animId, Sequence sequence) {
    	Client.spriteIsNull = false;
    	int type;
    	int id;
    	if (enabled) {
    		id = mediaIdEnabled;
    		type = mediaTypeEnabled;
    	} else {
    		type = modelTypeDisabled;
    		id = mediaIdDisabled;
    	}
    	if (type == 0)
    		return null;
    	if (type == 1 && id == -1)
    		return null;
    	Model model = (Model) Client.modelCache.get((long) ((type << 16) + id));
    	if (model == null) {
    		if (type == 1) {
    			model = Model.get(Client.interfaceModelFetcher, id, 0);
    			if (model == null) {
    				Client.spriteIsNull = true;
    				return null;
    			}
    			model.skin();
    			model.preProcess(64, 768, -50, -10, -50, true);
    		}
    		if (type == 2) {
    			model = NpcDefinition.forID(id).getHeadModel();
    			if (model == null) {
    				Client.spriteIsNull = true;
    				return null;
    			}
    			model.skin();
    			model.preProcess(64, 768, -50, -10, -50, true);
    		}
    		if (type == 3) {
    			if (class34 == null)
    				return null;
    			model = class34.method696();
    			if (model == null) {
    				Client.spriteIsNull = true;
    				return null;
    			}
    			model.skin();
    			model.preProcess(64, 768, -50, -10, -50, true);
    		}
    		if (type == 4) {
    			ItemDefinition def = ItemDefinition.forID(id);
    			model = def.preProcess(10, false);
    			if (model == null) {
    				Client.spriteIsNull = true;
    				return null;
    			}
    			model.skin();
    			model.preProcess(def.lightness + 64, def.shading + 768, -50, -10, -50, true);
    		}
    		Client.modelCache.put(model, (long) (id + (type << 16)));
    	}
    	if (sequence != null)
    		model = sequence.method224(model, animId);
    	return model;
    }
    
    final Sprite getSprite(int id) {
		Client.spriteIsNull = false;
		if (id < 0 || id >= spriteID.length)
		    return null;
		int spriteId = spriteID[id];
		if (spriteId == -1)
		    return null;
		Sprite sprite = (Sprite) Client.spriteCache.get((long) spriteId);
		if (sprite != null)
		    return sprite;
		sprite = Client.fetchSingleSprite(0, Client.interfaceSpriteFetcher, spriteId);
		if (sprite == null)
		    Client.spriteIsNull = true;
		else
		    Client.spriteCache.put(sprite, (long) spriteId);
		return sprite;
    }
    
    final void swapInventoryItems(int src, int dest) {
    	int id = inv[src];
    	inv[src] = inv[dest];
	    inv[dest] = id;
	    id = invStackSizes[src];
	    invStackSizes[src] = invStackSizes[dest];
	    invStackSizes[dest] = id;
    }
    
    static final RSInterface getRSInterface(int hash) {
		int id = hash >> 16;
		int child = hash & 0xffff;
		if (Client.interfaceCache[id] == null || (Client.interfaceCache[id][child] == null)) {
			boolean loaded = Client.loadInterface(id);
			if (!loaded)
				return null;
		}
		return Client.interfaceCache[id][child];
	}

	public RSInterface() {
    	anInt1748 = 0;
    	invSpritePadY = 0;
    	swapDeletesTarget = false;
    	anInt1805 = 0;
    }
}