/* Class59 - Decompiled by JODE
 * Visit http://jode.sourceforge.net/
 */

final class CollisionMap {
	
    int[][] collisionFlags;
    private int baseY;
    private int baseX;
    private int offsetY;
    private int offsetX;
    
    final void addClipping(int y, boolean walkable, int direction, int x, int sizeX, int sizeY) {
    	x -= offsetX;
    	y -= offsetY;
    	if (direction == 1 || direction == 3) {
    		int sizeX2 = sizeX;
    		sizeX = sizeY;
    		sizeY = sizeX2;
    	}
    	int shift = 256;
    	if (walkable)
    		shift += 131072;
    	for (int offX = x; offX < x + sizeX; offX++) {
    		if (offX >= 0 && offX < baseX) {
    			for (int offY = y; offY < sizeY + y; offY++) {
    				if (offY >= 0 && baseY > offY)
    					addClip(offX, offY, shift);
    			}
    		}
    	}
    }
    
    final void removeClipping(int direction, int sizeY, int x, int y, boolean walkable, int sizeX) {
    	x -= offsetX;
    	y -= offsetY;
    	if (direction == 1 || direction == 3) {
    		int sizeX2 = sizeX;
    		sizeX = sizeY;
    		sizeY = sizeX2;
    	}
    	int shift = 256;
    	if (walkable)
    		shift += 131072;
    	for (int offX = x; x + sizeX > offX; offX++) {
    		if (offX >= 0 && baseX > offX) {
    			for (int offY = y; y + sizeY > offY; offY++) {
    				if (offY >= 0 && baseY > offY)
    					removeClip(offX, offY, shift);
    			}
    		}
    	}
    }
    
    final void method869(int x, int y) {
    	x -= offsetX;
    	y -= offsetY;
    	collisionFlags[x][y] &= 14680063;
    }
    
    final void method882(int x, int y) {
    	y -= offsetY;
    	x -= offsetX;
    	collisionFlags[x][y] |= 2097152;
    }
    
    private final void addClip(int x, int y, int shift) {
    	collisionFlags[x][y] |= shift;
    }
    
    private final void removeClip(int x, int y, int shift) {
    	collisionFlags[x][y] &= 16777215 - shift;
    }
    
    final boolean method874(int i, int i_26_, int i_27_, int i_28_, int i_29_, int i_30_, int i_32_) {
    	int i_33_ = i_26_ + (i_30_ - 1);
    	int i_34_ = i_27_ - 1 + i;
    	if (i_30_ <= i_29_ && i_29_ <= i_33_ && i_28_ >= i && i_28_ <= i_34_)
    		return true;
    	if (i_30_ - 1 == i_29_ && i_28_ >= i && i_34_ >= i_28_
    			&& ((collisionFlags[i_29_ - offsetX][i_28_ - offsetY]) & 0x8) == 0
    			&& (i_32_ & 0x8) == 0)
    		return true;
    	if (i_29_ == i_33_ + 1 && i <= i_28_ && i_34_ >= i_28_
    			&& ((collisionFlags[i_29_ - offsetX][i_28_ - offsetY]) & 0x80) == 0
    			&& (i_32_ & 0x2) == 0)
    		return true;
    	if (i_28_ == i - 1 && i_29_ >= i_30_ && i_33_ >= i_29_
    			&& ((collisionFlags[i_29_ - offsetX][i_28_ - offsetY]) & 0x2) == 0
    			&& (i_32_ & 0x4) == 0)
    		return true;
    	if (i_28_ == i_34_ + 1 && i_30_ <= i_29_ && i_33_ >= i_29_
    			&& ((collisionFlags[i_29_ - offsetX][i_28_ - offsetY]) & 0x20) == 0
    			&& (i_32_ & 0x1) == 0)
    		return true;
    	return false;
    }
    
    final boolean method875(int i_35_, int i_36_, int i_37_, int i_38_, int i_39_, int i_40_) {
    	if (i_39_ == i_37_ && i_40_ == i_35_)
    		return true;
    	i_37_ -= offsetX;
    	i_39_ -= offsetX;
    	i_40_ -= offsetY;
    	i_35_ -= offsetY;
    	if (i_38_ == 0) {
    		if (i_36_ == 0) {
    			if (i_39_ - 1 == i_37_ && i_40_ == i_35_)
    				return true;
    			if (i_37_ == i_39_ && i_40_ + 1 == i_35_ && (collisionFlags[i_37_][i_35_] & 0x1280120) == 0)
    				return true;
    			if (i_37_ == i_39_ && i_35_ == i_40_ - 1 && (collisionFlags[i_37_][i_35_] & 0x1280102) == 0)
    				return true;
    		} else if (i_36_ == 1) {
    			if (i_37_ == i_39_ && i_40_ + 1 == i_35_)
    				return true;
    			if (i_39_ - 1 == i_37_ && i_40_ == i_35_ && (collisionFlags[i_37_][i_35_] & 0x1280108) == 0)
    				return true;
    			if (i_37_ == i_39_ + 1 && i_35_ == i_40_ && (collisionFlags[i_37_][i_35_] & 0x1280180) == 0)
    				return true;
    		} else if (i_36_ == 2) {
    			if (i_37_ == i_39_ + 1 && i_35_ == i_40_)
    				return true;
    			if (i_39_ == i_37_ && i_35_ == i_40_ + 1 && (collisionFlags[i_37_][i_35_] & 0x1280120) == 0)
    				return true;
    			if (i_37_ == i_39_ && i_40_ - 1 == i_35_ && (collisionFlags[i_37_][i_35_] & 0x1280102) == 0)
    				return true;
    		} else if (i_36_ == 3) {
    			if (i_39_ == i_37_ && i_40_ - 1 == i_35_)
    				return true;
    			if (i_37_ == i_39_ - 1 && i_35_ == i_40_ && (collisionFlags[i_37_][i_35_] & 0x1280108) == 0)
    				return true;
    			if (i_39_ + 1 == i_37_ && i_35_ == i_40_ && (collisionFlags[i_37_][i_35_] & 0x1280180) == 0)
    				return true;
    		}
    	}
    	if (i_38_ == 2) {
    		if (i_36_ == 0) {
    			if (i_39_ - 1 == i_37_ && i_40_ == i_35_)
    				return true;
    			if (i_39_ == i_37_ && i_40_ + 1 == i_35_)
    				return true;
    			if (i_39_ + 1 == i_37_ && i_35_ == i_40_ && (collisionFlags[i_37_][i_35_] & 0x1280180) == 0)
    				return true;
    			if (i_37_ == i_39_ && i_40_ - 1 == i_35_ && (collisionFlags[i_37_][i_35_] & 0x1280102) == 0)
    				return true;
		    } else if (i_36_ == 1) {
		    	if (i_39_ - 1 == i_37_ && i_35_ == i_40_ && (collisionFlags[i_37_][i_35_] & 0x1280108) == 0)
				    return true;
				if (i_37_ == i_39_ && i_35_ == i_40_ + 1)
				    return true;
				if (i_37_ == i_39_ + 1 && i_40_ == i_35_)
					return true;
				if (i_39_ == i_37_ && i_35_ == i_40_ - 1 && (collisionFlags[i_37_][i_35_] & 0x1280102) == 0)
				    return true;
		    } else if (i_36_ == 2) {
		    	if (i_39_ - 1 == i_37_ && i_40_ == i_35_ && (collisionFlags[i_37_][i_35_] & 0x1280108) == 0)
		    		return true;
		    	if (i_39_ == i_37_ && i_40_ + 1 == i_35_ && (collisionFlags[i_37_][i_35_] & 0x1280120) == 0)
		    		return true;
		    	if (i_39_ + 1 == i_37_ && i_40_ == i_35_)
		    		return true;
		    	if (i_37_ == i_39_ && i_35_ == i_40_ - 1)
		    		return true;
		    } else if (i_36_ == 3) {
		    	if (i_39_ - 1 == i_37_ && i_35_ == i_40_)
		    		return true;
		    	if (i_37_ == i_39_ && i_35_ == i_40_ + 1 && ((collisionFlags[i_37_][i_35_]) & 0x1280120) == 0)
		    		return true;
		    	if (i_37_ == i_39_ + 1 && i_40_ == i_35_ && ((collisionFlags[i_37_][i_35_]) & 0x1280180) == 0)
		    		return true;
		    	if (i_39_ == i_37_ && i_35_ == i_40_ - 1)
		    		return true;
		    }
    	}
		if (i_38_ == 9) {
			if (i_39_ == i_37_ && i_40_ + 1 == i_35_ && ((collisionFlags[i_37_][i_35_] & 0x20) == 0))
				return true;
			if (i_39_ == i_37_ && i_40_ - 1 == i_35_ && ((collisionFlags[i_37_][i_35_] & 0x2) == 0))
				return true;
			if (i_37_ == i_39_ - 1 && i_35_ == i_40_ && ((collisionFlags[i_37_][i_35_] & 0x8) == 0))
				return true;
			if (i_39_ + 1 == i_37_ && i_40_ == i_35_ && ((collisionFlags[i_37_][i_35_] & 0x80) == 0))
				return true;
		}
		return false;
    }
    
    final boolean method877(int i, int i_47_, int i_48_, int i_49_, int i_50_, int i_51_) {
    	if (i_47_ == i_48_ && i_50_ == i_49_)
    		return true;
    	i_50_ -= offsetY;
    	i_48_ -= offsetX;
    	i_49_ -= offsetY;
    	i_47_ -= offsetX;
		if (i_51_ == 6 || i_51_ == 7) {
			if (i_51_ == 7)
				i = i + 2 & 0x3;
			if (i == 0) {
				if (i_48_ + 1 == i_47_ && i_49_ == i_50_ && (collisionFlags[i_47_][i_50_] & 0x80) == 0)
					return true;
				if (i_47_ == i_48_ && i_50_ == i_49_ - 1 && (collisionFlags[i_47_][i_50_] & 0x2) == 0)
					return true;
			} else if (i == 1) {
				if (i_48_ - 1 == i_47_ && i_49_ == i_50_ && (collisionFlags[i_47_][i_50_] & 0x8) == 0)
					return true;
				if (i_48_ == i_47_ && i_49_ - 1 == i_50_ && (collisionFlags[i_47_][i_50_] & 0x2) == 0)
					return true;
			} else if (i == 2) {
				if (i_48_ - 1 == i_47_ && i_50_ == i_49_ && ((collisionFlags[i_47_][i_50_]) & 0x8) == 0)
					return true;
				if (i_48_ == i_47_ && i_49_ + 1 == i_50_ && ((collisionFlags[i_47_][i_50_]) & 0x20) == 0)
					return true;
			} else if (i == 3) {
				if (i_47_ == i_48_ + 1 && i_49_ == i_50_ && ((collisionFlags[i_47_][i_50_]) & 0x80) == 0)
					return true;
				if (i_47_ == i_48_ && i_49_ + 1 == i_50_ && ((collisionFlags[i_47_][i_50_]) & 0x20) == 0)
					return true;
			}
		}
		if (i_51_ == 8) {
			if (i_47_ == i_48_ && i_49_ + 1 == i_50_ && ((collisionFlags[i_47_][i_50_] & 0x20) == 0))
				return true;
			if (i_47_ == i_48_ && i_50_ == i_49_ - 1 && ((collisionFlags[i_47_][i_50_] & 0x2) == 0))
				return true;
			if (i_48_ - 1 == i_47_ && i_50_ == i_49_ && ((collisionFlags[i_47_][i_50_] & 0x8) == 0))
				return true;
			if (i_47_ == i_48_ + 1 && i_50_ == i_49_ && ((collisionFlags[i_47_][i_50_] & 0x80) == 0))
				return true;
		}
		return false;
    }
    
    final void removeClipping(boolean walkable, int x, int direction, int type, int y) {
    	x -= offsetX;
    	y -= offsetY;
    	if (type == 0) {
    		if (direction == 0) {
    			removeClip(x, y, 128);
    			removeClip(x - 1, y, 8);
    		}
    		if (direction == 1) {
    			removeClip(x, y, 2);
    			removeClip(x, y + 1, 32);
		    }
		    if (direction == 2) {
		    	removeClip(x, y, 8);
		    	removeClip(x + 1, y, 128);
		    }
		    if (direction == 3) {
		    	removeClip(x, y, 32);
		    	removeClip(x, y - 1, 2);
		    }
    	}
    	if (type == 1 || type == 3) {
    		if (direction == 0) {
    			removeClip(x, y, 1);
    			removeClip(x - 1, y + 1, 16);
    		}
    		if (direction == 1) {
    			removeClip(x, y, 4);
    			removeClip(x + 1, y + 1, 64);
    		}
    		if (direction == 2) {
    			removeClip(x, y, 16);
    			removeClip(x + 1, y - 1, 1);
    		}
    		if (direction == 3) {
    			removeClip(x, y, 64);
    			removeClip(x - 1, y - 1, 4);
    		}
    	}
    	if (type == 2) {
    		if (direction == 0) {
    			removeClip(x, y, 130);
    			removeClip(x - 1, y, 8);
    			removeClip(x, y + 1, 32);
    		}
    		if (direction == 1) {
    			removeClip(x, y, 10);
    			removeClip(x, y + 1, 32);
    			removeClip(x + 1, y, 128);
    		}
    		if (direction == 2) {
    			removeClip(x, y, 40);
    			removeClip(x + 1, y, 128);
    			removeClip(x, y - 1, 2);
    		}
    		if (direction == 3) {
    			removeClip(x, y, 160);
    			removeClip(x, y - 1, 2);
				removeClip(x - 1, y, 8);
    		}
    	}
    	if (walkable) {
    		if (type == 0) {
    			if (direction == 0) {
    				removeClip(x, y, 65536);
    				removeClip(x - 1, y, 4096);
    			}
    			if (direction == 1) {
    				removeClip(x, y, 1024);
    				removeClip(x, y + 1, 16384);
    			}
    			if (direction == 2) {
    				removeClip(x, y, 4096);
    				removeClip(x + 1, y, 65536);
    			}
    			if (direction == 3) {
    				removeClip(x, y, 16384);
    				removeClip(x, y - 1, 1024);
    			}
    		}
    		if (type == 1 || type == 3) {
    			if (direction == 0) {
    				removeClip(x, y, 512);
    				removeClip(x - 1, y + 1, 8192);
    			}
    			if (direction == 1) {
    				removeClip(x, y, 2048);
    				removeClip(x + 1, y + 1, 32768);
    			}
    			if (direction == 2) {
    				removeClip(x, y, 8192);
    				removeClip(x + 1, y - 1, 512);
    			}
    			if (direction == 3) {
    				removeClip(x, y, 32768);
    				removeClip(x - 1, y - 1, 2048);
    			}
    		}
    		if (type == 2) {
    			if (direction == 0) {
    				removeClip(x, y, 66560);
    				removeClip(x - 1, y, 4096);
    				removeClip(x, y + 1, 16384);
    			}
    			if (direction == 1) {
    				removeClip(x, y, 5120);
    				removeClip(x, y + 1, 16384);
    				removeClip(x + 1, y, 65536);
    			}
    			if (direction == 2) {
    				removeClip(x, y, 20480);
    				removeClip(x + 1, y, 65536);
    				removeClip(x, y - 1, 1024);
    			}
    			if (direction == 3) {
    				removeClip(x, y, 81920);
    				removeClip(x, y - 1, 1024);
    				removeClip(x - 1, y, 4096);
    			}
    		}
    	}
    }
    
    final void resetFlags() {
    	for (int x = 0; baseX > x; x++) {
    		for (int y = 0; y < baseY; y++) {
    			if (x == 0 || y == 0 || x == baseX - 1 || y == baseY - 1)
    				collisionFlags[x][y] = 16777215;
    			else
    				collisionFlags[x][y] = 16777216;
    		}
    	}
    }
    
    final void addClipping(int type, int x, int y, boolean walkable, int direction) {
    	x -= offsetX;
    	y -= offsetY;
    	if (type == 0) {
		    if (direction == 0) {
		    	addClip(x, y, 128);
		    	addClip(x - 1, y, 8);
		    }
		    if (direction == 1) {
		    	addClip(x, y, 2);
		    	addClip(x, y + 1, 32);
		    }
		    if (direction == 2) {
		    	addClip(x, y, 8);
		    	addClip(x + 1, y, 128);
		    }
		    if (direction == 3) {
		    	addClip(x, y, 32);
		    	addClip(x, y - 1, 2);
		    }
    	}
		if (type == 1 || type == 3) {
		    if (direction == 0) {
				addClip(x, y, 1);
				addClip(x - 1, y + 1, 16);
		    }
		    if (direction == 1) {
		    	addClip(x, y, 4);
		    	addClip(x + 1, y + 1, 64);
		    }
		    if (direction == 2) {
		    	addClip(x, y, 16);
		    	addClip(x + 1, y - 1, 1);
		    }
		    if (direction == 3) {
		    	addClip(x, y, 64);
		    	addClip(x - 1, y - 1, 4);
		    }
		}
		if (type == 2) {
		    if (direction == 0) {
		    	addClip(x, y, 130);
		    	addClip(x - 1, y, 8);
		    	addClip(x, y + 1, 32);
		    }
		    if (direction == 1) {
		    	addClip(x, y, 10);
		    	addClip(x, y + 1, 32);
		    	addClip(x + 1, y, 128);
		    }
		    if (direction == 2) {
		    	addClip(x, y, 40);
		    	addClip(x + 1, y, 128);
		    	addClip(x, y - 1, 2);
		    }
		    if (direction == 3) {
		    	addClip(x, y, 160);
				addClip(x, y - 1, 2);
				addClip(x - 1, y, 8);
		    }
		}
		if (walkable) {
			if (type == 0) {
				if (direction == 0) {
					addClip(x, y, 65536);
					addClip(x - 1, y, 4096);
				}
				if (direction == 1) {
					addClip(x, y, 1024);
					addClip(x, y + 1, 16384);
				}
				if (direction == 2) {
					addClip(x, y, 4096);
					addClip(x + 1, y, 65536);
				}
				if (direction == 3) {
					addClip(x, y, 16384);
					addClip(x, y - 1, 1024);
				}
			}
			if (type == 1 || type == 3) {
				if (direction == 0) {
					addClip(x, y, 512);
					addClip(x - 1, y + 1, 8192);
				}
				if (direction == 1) {
					addClip(x, y, 2048);
					addClip(x + 1, y + 1, 32768);
				}
				if (direction == 2) {
					addClip(x, y, 8192);
					addClip(x + 1, y - 1, 512);
				}
				if (direction == 3) {
					addClip(x, y, 32768);
					addClip(x - 1, y - 1, 2048);
				}
			}
			if (type == 2) {
				if (direction == 0) {
					addClip(x, y, 66560);
					addClip(x - 1, y, 4096);
					addClip(x, y + 1, 16384);
				}
				if (direction == 1) {
					addClip(x, y, 5120);
					addClip(x, y + 1, 16384);
					addClip(x + 1, y, 65536);
				}
				if (direction == 2) {
					addClip(x, y, 20480);
					addClip(x + 1, y, 65536);
					addClip(x, y - 1, 1024);
				}
				if (direction == 3) {
					addClip(x, y, 81920);
					addClip(x, y - 1, 1024);
					addClip(x - 1, y, 4096);
				}
		    }
		}
    }
    
    CollisionMap(int x, int y) {
		baseX = x;
		baseY = y;
		collisionFlags = new int[baseX][baseY];
		offsetY = 0;
		offsetX = 0;
		resetFlags();
    }
}
